import 'package:dio/dio.dart';

import 'data_client.dart';

// Standard IJsonClient Interface Implementation using Dio

class DioJsonClient implements IDataClient {
  final Dio dio;

  DioJsonClient(this.dio);

  Dio get dioClient => dio;

  @override
  Future<void> delete(String path,
      {Map<String, dynamic> queryParameters}) async {
    await dio.delete(path, queryParameters: queryParameters);
  }

  @override
  Future<Map<String, dynamic>> get(String path,
      {Map<String, dynamic> queryParameters}) async {
    var dioResponse = await dio.get(path, queryParameters: queryParameters);
    return dioResponse.data;
  }

  @override
  Future patch(String path,
      {data, Map<String, dynamic> queryParameters}) async {
    await dio.patch(path, data: data, queryParameters: queryParameters);
  }

  @override
  Future<void> post(String path,
      {data, Map<String, dynamic> queryParameters}) async {
    await dio.post(path, data: data, queryParameters: queryParameters);
  }

  @override
  Future<void> put(String path,
      {data, Map<String, dynamic> queryParameters}) async {
    await dio.put(path, data: data, queryParameters: queryParameters);
  }
}
